/* tab setting : 4
 *
 * Console definition
 *
 * 6 december 2k	fnjordy
 * 30 december 2k             added trace
 */

/* precompiled jism */
#include "StdAfx.h"

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "console.h"


/* locals */
static FILE *fptr;

#define DEBUG_FILE "debug.log"

static char* time_format = "%Y-%m-%d %H:%M:%S";
static char* roles[] = { "Trace",
						 "Info",
						 "Warning",
						 "Error",
						 "Fatal" };



/* code */

int
tracef (char* this_file, 
		char* this_version,
		int line_number, 
		trace_t role)
{
	char buffer[1024];
	time_t uct_time;
	struct tm* display_time;

	time (&uct_time);
	display_time = localtime (&uct_time);
	strftime (buffer, sizeof (buffer), time_format, display_time);
	return fprintf (fptr, "%s %s:%s %s:%i:", buffer, roles[role], this_file, this_version, line_number);
}


void 
printf (char *fmt, ...)
{
	char buffer[1024];
    va_list	va;

    va_start (va, fmt);
    vsprintf (buffer, fmt, va);
    va_end (va);

	fputs (buffer, fptr);
	fflush (fptr);
}

void 
init_console (void)
{
	if ((fptr = fopen (DEBUG_FILE, "w")) == NULL) {
		/* arse */
		exit (-1);
	}
}

/* eof */